'user strict';

var xSelector = function (selector) {
    return {
        selector: selector,
        locateStrategy: 'xpath'
    }
};

var nodeCommand= {
    clickNnet: function(callback) {
        this.api.pause(1000);
        return this.click('@nodeNnet', callback);
    },

    addNode: function(callback) {
        this.api.pause(1000);
        return this.click('@nNetExec', callback);
    },

    openPreferences: function(callback) {
        this.api.pause(1000);
        return this.click('@preferencesBtn', callback);
    },

    clickPackages: function(callback) {
        this.api.pause(1000);
        return this.click('@packagesBtn')
            .waitForElementVisible('@packagesDiv', 1000, callback);
    },
    disableNnetDef: function (callback) {
        this.api.pause(1000);
        return this.click('@nNetBtn', callback);
    },
    enableNnetDef: function (callback) {
        this.api.pause(1000);
        return this.click('@nNetBtn', callback);
    },
    closePreferences: function (callback) {
        this.api.pause(1000);
        return this.click('@closePBtn', callback);
    },
    clickHideList: function (callback) {
        this.api.pause(1000);
        return this.click('@hideShowBtn', callback);
    },
    clickShowList: function (callback) {
        this.api.pause(1000);
        return this.click('@hideShowBtn', callback)
            .assert.visible('@nodeList');
    },
    addSheet: function (callback) {
        this.api.pause(1000);
        return this.click('@addSheetBtn', callback);
    },
    clickDynamic: function (callback) {
        this.api.pause(1000);
        return this.click('@dynamicNode', callback);
    }
};

module.exports = {
    commands: [nodeCommand],
    elements: {
        nodeNnet: xSelector('//*[@id="nodelist"]/li[1]'),
        nNetExec: xSelector('//*[@id="nodelist"]/li[1]/ul/li[1]'),

        nNetExecId: xSelector('//*[@id="node_NNetExec_1"]'),
        nNetUl: xSelector('//*[@id="nodelist"]/li[1]/ul'),
        preferencesBtn: xSelector('//*[@id="preferenceButton"]'),
        preferencesDialog: xSelector('/html/body/div[contains(@aria-describedby, "preferenceDialog")]'),
        packagesBtn: xSelector('//*[@id="packagesButton"]'),
        packagesDiv: xSelector('//*[@id="preferenceDialog"]/div[2]/div[2]'),

        inputSearch: xSelector('//*[@id="nodelistSearch"]/input'),
        localizeMusic: xSelector('//*[@id="flatNodelist"]/li[1]'),
        constantLocalization: xSelector('//*[@id="flatNodelist"]/li[2]'),
        displayLocalization: xSelector('//*[@id="flatNodelist"]/li[3]'),
        harkLocalization: xSelector('//*[@id="flatNodelist"]/li[4]'),
        harkLocCor: xSelector('//*[@id="flatNodelist"]/li[5]'),

        nNetBtn: xSelector('//*[@id="preferenceDialog"]/div[2]/div[2]/form/fieldset[1]/button'),
        nnetDefField: xSelector('//*[@id="preferenceDialog"]/div[2]/div[2]/form/fieldset[1]/button/span[2]'),
        nnetSelect: xSelector('//*[@id="preferenceDialog"]/div[2]/div[2]/form/fieldset[1]/select'),
        packagesSpan: xSelector('//*[@id="packagesButton"]/span[2]'),
        closePBtn: xSelector('/html/body/div[contains(@aria-describedby, "preferenceDialog")]/div/button'),

        hideShowBtn: xSelector('//*[@id="minimizeNodelistButton"]'),
        hideShowSpan: xSelector('//*[@id="minimizeNodelistButton"]/span'),
        nodeList: xSelector('//*[@id="sidebar"]'),

        addSheetBtn: xSelector('//*[@id="addSheetButton"]'),
        addSheetDialog: xSelector('/html/body/div[9]'),
        addBtn: xSelector('/html/body/div[contains(@aria-describedby, "addSheetDialog")]/div/div/button/span[text()="Add"]'),
        addSheetInput: xSelector('//*[@id="addSheetName"]'),
        sheetTab: xSelector('//*[@id="ui-id-675"]'),
        dynamicNode: xSelector('//*[@id="nodelist"]/li[34]'),
        dynamicA: xSelector('//*[@id="nodelist"]/li[34]/ul'),
        nodeListA: xSelector('//*[@id="flatNodelist"]/li[@key="a"]'),
        nodeListB: xSelector('//*[@id="flatNodelist"]/li[@key="b"]'),
        nodeDynamic: xSelector('//*[@id="flatNodelist"]/li[@key="Dynamic"]'),

        versionBtn: xSelector('//*[@id="preferenceDialog"]/div[1]/ul/li[3]/button'),
        nnetList: xSelector('//*[@id="nodelist"]/li[@key="NNet"]')
    }
};