import unittest
from selenium import webdriver
from selenium.webdriver.common.keys import Keys
import harkdesigner


class PythonNode (harkdesigner.TestHarkDesigner):
    def test_makefig(self):
        self.zoom(3)
        self.setDisplay("Line", "Lines")

        self.addSheet("LOOP0", "iterator")

        # build LOOP 0
        self.activateSheet("LOOP0")

        self.addNode("AudioStreamFromWave")
        self.addNode("MultiFFT")
        self.addNode("LocalizeMUSIC")
        self.addNode("SourceTracker")
        self.addNode("DisplayLocalization")
        self.reshape()

        self.connect("node_AudioStreamFromWave_1", "AUDIO",
                     "node_MultiFFT_1", "INPUT")
        self.connect("node_MultiFFT_1", "OUTPUT",
                     "node_LocalizeMUSIC_1", "INPUT")
        self.connect("node_LocalizeMUSIC_1", "OUTPUT",
                     "node_SourceTracker_1", "INPUT")
        self.connect("node_SourceTracker_1", "OUTPUT",
                     "node_DisplayLocalization_1", "SOURCES")

        self.addTerminalRole(
            "node_AudioStreamFromWave_1", "INPUT", "Input")
        self.addTerminalRole(
            "node_AudioStreamFromWave_1", "NOT_EOF", "Condition")
        self.addTerminalRole(
            "node_DisplayLocalization_1", "OUTPUT", "Output")

        # build MAIN
        self.activateSheet("MAIN")
        self.addNode("Constant")
        self.addNode("InputStream")
        self.addNode("LOOP0")
        self.reshape()

        self.connect("node_Constant_1", "VALUE",
                     "node_InputStream_1", "INPUT")
        self.connect("node_InputStream_1", "OUTPUT",
                     "node_LOOP0_1", "INPUT")
        self.addTerminalRole("node_LOOP0_1", "OUTPUT", "Output")

        # take a picture
        self.reshape()
        self.screenshot("png", "tutorial1-56_")

if __name__ == "__main__":
    unittest.main()
